window.dlog = (message) ->
	console.log message

window.session_array = []

window.activity = (activityString) ->
	model = Strongspace.SavedSessions.get(activityString.split(":")[2])
	model.activity(activityString)


Backbone.Layout.configure
	manage: true
	fetch: (name) ->
		return new window.EJS {url: "javascripts/templates/" + name + ".ejs"}

	render: (template, context) ->
		return template.render(context)

window.testing = false

window.oauthemail = null
window.oauthrefresh = null

window.setOauthCredentials = (email, refresh) =>
	window.oauthemail = email
	window.oauthrefresh = refresh

window.Strongspace =
	Models: {}
	Collections: {}
	Views: {}
	Routers: {}
	
	SessionSync: null
	SavedSessions: null
	Popover: null
	Sidebar: null
	List: null
	Settings: null
	Layout: null
	Details: null

	initialize: () ->
		self = @
		if window.testing == false
			$("body").attr("oncontextmenu", "return false")

		if settings.platform() == "mac"
			$("#windows-stylesheet").remove()

		Strongspace.Settings = {}
		Strongspace.Settings["more_options"] = false
		Strongspace.Settings["selected"] = null

		Strongspace.List = new Strongspace.Views.List(template: "list")
		Strongspace.Sidebar = new Strongspace.Views.Sidebar(template: "sidebar")
		Strongspace.Settings = new Strongspace.Views.Settings(template: "settings")

		Strongspace.Layout = new Backbone.Layout(
			template: "layout"
			views:
				"#sidebar": Strongspace.Sidebar
				"#content": Strongspace.List
				"#settings" : Strongspace.Settings
		)


		Strongspace.Layout.$el.appendTo("#app");

		Strongspace.Layout.render()

		document.title = 'ExpanDrive 3'

		$("select").blur()

		today = new Date()
		expiration = new Date()
		expiration.setFullYear(2013, 4, 11)

		if false #today > expiration
			setTimeout ( ->
				 $("li.settings").click()
				 $("#sidebar li").hide()
				 alert "This development release has expired, please update to a newer version"
			), 100
		else
			setTimeout ( ->
				if loginitem.launchedAtLogon()
					Strongspace.SavedSessions.startAllForLogon()
			), 1000
		setTimeout ( ->
			expandrivelicense.validate()
			if (expandrivelicense.newUser() and license.licenseSHA1() != "") or (expandrivelicense.inTrial() and license.licenseV2SHA1() != "")
				expandrivelicense.attemptV3AutoUpgrade()
			#self.showSettings()
		), 200
	
	collapseListifNecessary: () ->
		if $(window).width() < 600 and ($("#settings").position().left < 0 and !$("#sidebar li.active").hasClass("new"))
			$("#details").hide()
			$("#sessions").data("orig_width", $("#sessions").width())
			$("#sessions").width(450)
		else if $("#settings").position().left < 0
			$("#details").show()
			$("#sessions").width($("#sessions").data("orig_width"))
		
	applicationShouldterminate: () ->
		#alert "Term"
		Strongspace.SavedSessions.stopAll()
		return true

	startAll: () ->
#   alert "Startall"
		Strongspace.SavedSessions.startAll()

	stopAll: () ->
		Strongspace.SavedSessions.stopAll()
	
	startActivity: (id) ->
		@saved_sessions.startActivity(id)

	stopActivity: (id) ->
		@saved_sessions.stopActivity(id)

	removeSession: (id) ->
		model = Strongspace.SavedSessions.get(id)
		model.stop()
		Strongspace.SavedSessions.remove(model)
		model.destroy()
		Strongspace.List.render()

	listSessions: () ->
		ret =  "=== Available drives\n"
		for session in Strongspace.SavedSessions.models
			ret += session.get("name") + "\n"

		return ret

	connectSession: (id) ->
		if expandrivelicense.newUser()
			return

		model = Strongspace.SavedSessions.get(id)

		if model == undefined
			for session in Strongspace.SavedSessions.models
				if session.get("name") == id
					model = session
					break
		if model == undefined
			return "#{id} is an invalid drive\n"

		if not (model.get('status') == "connected" or model.get('status') == "connecting")
			model.start()
		if model.get('status') == "connected"
			model.reveal()
		return "Connecting #{id}\n"

	ejectSession: (id) ->
		if expandrivelicense.newUser()
			return
		model = Strongspace.SavedSessions.get(id)
		if model == undefined
			for session in Strongspace.SavedSessions.models
				if session.get("name") == id
					model = session
					break
		if model == undefined
			return "#{id} is an invalid drive\n"
			
		model.eject()

		return "Ejected #{id}\n"

	newSession: () ->
		$("li.new").click()


	showSettings: () ->
		$("li.settings").click()

	showLicense: () ->
		$("li.license").click()

	revealSession: (id) ->
		model = Strongspace.SavedSessions.get(id)
		model.reveal()

	sendMessage: (id, message) ->
		model = Strongspace.SavedSessions.get(id)
		model.activity(message)

	inputKey: (keyString) ->
		alert keyString

	getDriveArray: () ->
		if expandrivelicense.newUser()
			return null
		return JSON.stringify(Strongspace.SavedSessions.models)


class ExpanDriveLicense

	validate: () ->
		if @inTrial() and @daysLeftInTrial() < 0
			alert "Your free trial has expired and ExpanDrive will close after 10 minutes."
			setTimeout ( ->
				if @inTrial
					settings.sendToStore()
					expandrive.quit()
			), (60*10*1000)

	getString: (key) ->
		return license.getString(key)

	licenseSHA1: () ->
		return license.getSHA1()

	validForVersion: () ->
		if @getString("product_version") != ""
			return @getString("product_version")
		if @getString("version") != ""
			return @getString("version")
		return "1"

	statusMessage: () ->
		if @inTrial()
			return @validV3TrialLicenseMessage()

		if not @needsLicense()
			return @validV3LicenseMessage()

		if @validForVersion() == "2"
			return @validV2LicenseMessage()

		return "#{@validForVersion()} #{@inTrial()}"

	daysLeftInTrial: () ->
		if @getString("in_trial") == "true"
			today = new Date()
			d = Date.parse(@getString('valid_until'))
			days_left = Math.floor((((d - today) / (60*60*24*1000)) + 1))
			return days_left
		else
			return 0

	validV3TrialLicenseMessage: () ->
		days_left = @daysLeftInTrial()
		if days_left > 1
			return "#{days_left} days left in your free trial."
		else if days_left == 1 or days_left == 0 
			return "1 day left in your free trial."
		else
			return "Your free trial has expired"


	validV3LicenseMessage: () ->
		return "Registered to #{@getString('name')}"

	validV2LicenseMessage: () ->
		return "You are currently licensed for an older version of ExpanDrive."

	upgradeButtonPrompt: () ->
		if @validForVersion() == "2" or @validForVersion() == "1"
			return "Upgrade to ExpanDrive 3"
		else
			return "Buy an ExpanDrive 3 license"

	inTrial: () ->
		if @getString("in_trial") == "true" and @validForVersion() == "3"
			dlog
			return true
		else
			return false

	needsLicense: () ->
		if @validForVersion() == "3" and not @inTrial()
			return false
		else
			return true

	newUser: () ->
		if license.validLicense() == false or @validForVersion() != "3"
			return true

		return false

	activeLicense: () ->
		if @newUser() 
			return false

		return true

	attemptV3AutoUpgrade: () ->
		$.ajax
			url: "https://secure.expandrive.com/store/order/license"
			type: "POST"

			data: 
				"previous_sha1" : license.licenseV2SHA1()
				
			success: (data) ->
				alert "You have been automatically upgraded to ExpanDrive 3!"
				license.setLicenseString(data)
				Strongspace.Sidebar.render()
				Strongspace.Details.render()
				Strongspace.Settings.render()
				Strongspace.newSession()


window.expandrivelicense = new ExpanDriveLicense


